#include "Form1.frm"
/*Esta utilidad es funcional, solo no convierte dbf con campos memo, aunado al hecho
de que las funciones para sql son lentas al escribir en el disco duro
Para hacer eficiente una conversion de muchos datos se recomiendo utilizar
discos RAM */

#define SQLITE_OPEN_READONLY                                                   1
#define SQLITE_OPEN_READWRITE                                                  2
#define SQLITE_OPEN_CREATE                                                     4

#define SQLITE_OK                                                              0
#define SQLITE_ERROR                                                           1
#define SQLITE_CANTOPEN                                                       14
#define SQLITE_CONSTRAINT                                                     19
#define SQLITE_ROW                                                           100
#define SQLITE_DONE                                                          101

/*
 * Event OnCreate.
 */
method Form1OnCreate( oSender ) class TForm1

   ::btnDb:enabled:=.F.
   ::btnTablas:enabled:=.F.
   ::btnDatos:enabled:=.F.  

return
/*
 * Event OnClick.
 */
method buscafldr( oSender ) class TForm1
local afiles:={}
  ::FldrOrigen:Folder = ::NomDir:Caption
  IF ::FldrOrigen:Execute()
     ::NomDir:Caption = PADR( ::FldrOrigen:Folder, 100)
  ENDIF
  afiles:=Directory(::NomDir:Caption+"*.dbf")
  ::tablas:items:=afiles
  ::btnfolder:enabled:=.F.
  ::btnDb:enabled:=.T.
  ::btnDB:setfocus()

return

/*
 * Evento OnClick.
 */
method CrearDB( oSender ) class TForm1
local cDbName,nSlash:=0,pDb
   //Falta validar que no se quede en blanco
   if ::DbSql3:enabled
      ::cFileNom := ::NomDir:Caption + ::DbSql3:Caption+".db"
   else
      cDBName := ::NomDir:Caption
      nSlash := rat( '\', cDBName )
      if nSlash!=0
         if nSlash==len(cDBName)
            cDBName := substr( cDBName,1, nSlash -1 )
         endif
         nSlash := rat( '\', cDBName )
         if nSlash > 0
            cDBName := substr( cDBName, nSlash + 1 )
         endif
      endif
      ::cFileNom := ::NomDir:Caption + cDBName+".db"   
   endif
   //Crea la base contenedora si no existe por eso se abre para creacion y edicion
   if !File( ::cFileNom )
      MessageDlg( "No se encontr la base de datos, se va a crear una nueva base de datos.",  mtError, mbOk, poActiveCenter )
      if sqlite3_open_v2( ::cFileNom, @pDb, SQLITE_OPEN_READWRITE + SQLITE_OPEN_CREATE ) != SQLITE_OK
         MessageDlg( "No se pudo crear la base de datos.", mtError, mbOk, poActiveCenter )
         Application:Terminate()
         return
      endif
      sqlite3_close_v2( pDb )
   endif
   if(len(::tablas:items)!=0)
      ::btntablas:enabled:=.T.
   endif
   ::btnDB:enabled:=.F.
   ::IgualFldr:enabled:=.F.
   ::DbSql3:enabled:=.F.
   ::NomDir:enabled:=.F.
return


method creartablas( oSender ) class TForm1
local mSql:="",bsql:="",pDb
local afiles,i,j,nDot:=0,cDbName,cTablename:="",aEstructura:={},mFldNm,mFldType,mFldLen,mFldDec
   afiles:=::tablas:items
   for j:=1 to len(afiles)
      cDBName:=afiles[j,1]
      nDot:=rat(".",cDBName)
      if nDot!=0
         cDBName:=substr(cDBName,1,nDot-1)
         cTableName:=cDBName
         set default to &(::NomDir:Caption)
         if safe2open(::NomDir:Caption+cTablename)         
            DbUseArea( .T., "DbfNtx",cTableName , "Test", .T., .F. )
            aEstructura:=Test->(Dbstruct())
            Test->(dbclosearea())
            //Borra la tabla si existe previamente
            bSql:="DROP TABLE if exists "+cTablename
            if sqlite3_open_v2( ::cFileNom, @pDb, SQLITE_OPEN_READWRITE + SQLITE_OPEN_CREATE) == SQLITE_OK
               sqlite3_execute_query(pDb, bSql)
               sqlite3_close_v2( pDb )
            endif
            //Crea la tabla de acuerdo a la estructura del dbf
            mSql := "CREATE TABLE if not exists "+cTablename+" ("
            for i := 1 to len(aEstructura)
               mFldNm := aEstructura[i, 1] //DBS_NAME]
               mFldType := aEstructura[i,2] // DBS_TYPE]
               mFldLen := aEstructura[i,3] // DBS_LEN]
               mFldDec := aEstructura[i,4] // DBS_DEC]
               if i > 1
                  mSql += ", "
               endif
               mSql += alltrim(mFldNm)+" " 
               do case
               case mFldType = "C"
                  mSql += "CHAR("+LTRIM(STR(mFldLen))+")"
               case mFldType = "D"
                  mSql += "DATE"
               case mFldType = "T"
                  mSql += "DATETIME"
               case mFldType = "N"
                  if mFldDec > 0
                     mSql += "FLOAT"
                  else
                     mSql += "INTEGER"
                  endif
               case mFldType = "F"
                  mSql += "FLOAT"
               case mFldType = "I"
                  mSql += "INTEGER"
               case mFldType = "B"
                  mSql += "DOUBLE"
               case mFldType = "Y"
                  mSql += "FLOAT"
               case mFldType = "L"
                  mSql += "BOOL"
               case mFldType = "M"
                  mSql += "TEXT"
               case mFldType = "G"
                  mSql += "BLOB"
               otherwise
                  MessageDlg( "Campo de tipo invalido: "+mFldType, mtError, mbOk, poActiveCenter )
                  Application:Terminate()
                  return nil
               endcase
            next i
            mSql += ")"
            //Crea la tabla
            if sqlite3_open_v2( ::cFileNom, @pDb, SQLITE_OPEN_READWRITE + SQLITE_OPEN_CREATE) == SQLITE_OK
               sqlite3_execute_query(pDb, mSql)
               sqlite3_close_v2( pDb )
               ::tablas:items[j,2]:="ok"
               ::tablas:refresh()
            endif
         else
            ::tablas:items[j,2]:="X Memo"
            ::tablas:refresh()
         endif
      else
         ::tablas:items[j,2]:="X Dbf"
         ::tablas:refresh()
      endif
   next j
   ::btnDB:enabled:=.F.
   ::IgualFldr:enabled:=.F.
   ::DbSql3:enabled:=.F.
   ::NomDir:enabled:=.F.
   ::btntablas:enabled:=.F.
   ::btndatos:enabled:=.T.
return


method transdata( oSender ) class TForm1
local mSql:="",pDb,asql:={}
local afiles,i,j,k,l,nDot:=0,cDbName,cTablename:="",aEstructura:={},mFldNm
   afiles:=::tablas:items
   ::btndatos:enabled:=.F.
   ::global:position:=0
   ::global:min:=0
   ::global:max:=len(afiles)
   for j:=1 to len(afiles)
      asql:={}
      cDBName:=afiles[j,1]
      nDot:=rat(".",cDBName)
      if nDot!=0
         cDBName:=substr(cDBName,1,nDot-1)
         cTableName:=cDBName
         set default to &(::NomDir:Caption)
         if safe2open(::NomDir:Caption+cTablename)
            DbUseArea( .T., "DbfNtx",cTableName , "Test", .T., .F. )
            k:=Test->(lastrec())
            //Transfiere los datos a memoria
            aEstructura:=Test->(Dbstruct())
            l:=0
            test->(dbgotop())
            Do while !test->(eof())
            /*for a:=1 to k
               go a*/
               mSql := "INSERT INTO "+cDBName+" VALUES ("
               for i := 1 to len(aEstructura)
                  mFldNm := aEstructura[i, 1] //DBS_NAME]
                  if i > 1
                     mSql += ", "
                  endif
                  mSql += c2sql(&mFldNm)
               next i
               mSql += ")"
               aadd(aSql,mSql)
               l++
               test->(dbskip())
               ::tablas:items[j,3]:=transfor(100*l/k,"@Z 999.99%")
               ::tablas:refresh()
            enddo
            //next a
            Test->(dbclosearea())
         else
            //Archico Memo no encontrado
            ::tablas:items[j,3]:="X Memo"
            ::tablas:refresh()
         endif
      else
         //archivo invalido
         ::tablas:items[j,3]:="X Dbf"
         ::tablas:refresh()
      endif
      //Transferir memoria a archivo
      if sqlite3_open_v2( ::cFileNom, @pDb, SQLITE_OPEN_READWRITE) == SQLITE_OK
         ::avance:max:=k
         ::avance:min:=0
         ::avance:position:=0
         aeval(aSql,{|p1| sqlite3_execute_query( pDb,p1), ::avance:position++,sysrefresh()})
         sqlite3_close_v2( pDb )
      else
         //no se puede abrir para agregar
      endif
      ::global:position++
      ::global:refresh()
   next j
   ::btnDB:enabled:=.F.
   ::IgualFldr:enabled:=.F.
   ::DbSql3:enabled:=.F.
   ::NomDir:enabled:=.F.
   ::btntablas:enabled:=.F.
   MessageDlg( "Transferencia de datos terminada.",  mtError, mbOk, poActiveCenter )
   
return
/*
 * Evento OnChange.
 */
method IgualFldrOnChange( oSender ) class TForm1
   ::DbSql3:enabled:=!::IgualFldr:checked
return

/*
 * Evento OnClick.
 */
method btn2OnClick( oSender ) class TForm1
Application:Terminate()
//::close()
return

//funciones necesarias de terceros
function C2Sql(Value)
   local cValue := "",cdate := "", Eltipo:=valtype(value)
   if  Eltipo== "C" .and. len(alltrim(value)) > 0
      value := strtran(value,"'","''")
   endif
   if Eltipo== "N"
      cValue := AllTrim(Str(Value))
   elseif Eltipo=="D"
      if !Empty(Value)
         cdate := dtos(value)
         cValue := "'"+substr(cDate,1,4)+"-"+substr(cDate,5,2)+"-"+substr(cDate,7,2)+"'"
      else
         cValue := "''"
      endif
    elseif Eltipo$"CM"
      IF Empty( Value)
         cValue="''"
      ELSE
         cValue := "'" + value + "'"
      ENDIF
     elseif Eltipo=="L"
         cValue := AllTrim(Str(iif(Value == .F., 0, 1)))
     else
         cValue := "''"       // NOTE: Here we lose values we cannot convert
     endif
return cValue

function safe2open(file_name)
local handle, retval:=.t., first_byte,buffer:=" "
local fn:=trim(file_name)
if (handle:=fopen(fn+".dbf"))>-1
   fread(handle,@buffer,1)
   if(first_byte:=asc(buffer))==131
      retval:=.F. //file(fn+".dbt")     //no acepta archivos con memo
   elseif (first_byte:=asc(buffer))==245
      retval:=.f. //file(fn+".fpt")     //no acepta archivos con memo
   endif
   fclose(handle)
endif
return retval


FUNCTION SysRefresh()
RETURN Application:ProcessMessages()